"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defaultValue = defaultValue;
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _graphql = require("graphql");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function defaultGetDefaultFieldNames(type) {
  var fields = type.getFields(); // Is there an `id` field?

  if (fields['id']) {
    var res = ['id'];

    if (fields['email']) {
      res.push('email');
    } else if (fields['name']) {
      res.push('name');
    }

    return res;
  } // Is there an `edges` field?


  if (fields['edges']) {
    return ['edges'];
  } // Is there an `node` field?


  if (fields['node']) {
    return ['node'];
  }

  if (fields['nodes']) {
    return ['nodes'];
  } // Include all leaf-type fields.


  var leafFieldNames = [];
  Object.keys(fields).forEach(function (fieldName) {
    if ((0, _graphql.isLeafType)(fields[fieldName].type)) {
      leafFieldNames.push(fieldName);
    }
  });
  return leafFieldNames.slice(0, 2); // Prevent too many fields from being added
}

function isRequiredArgument(arg) {
  return (0, _graphql.isNonNullType)(arg.type) && arg.defaultValue === undefined;
}

function unwrapOutputType(outputType) {
  var unwrappedType = outputType;

  while ((0, _graphql.isWrappingType)(unwrappedType)) {
    unwrappedType = unwrappedType.ofType;
  }

  return unwrappedType;
}

function unwrapInputType(inputType) {
  var unwrappedType = inputType;

  while ((0, _graphql.isWrappingType)(unwrappedType)) {
    unwrappedType = unwrappedType.ofType;
  }

  return unwrappedType;
}

function coerceArgValue(argType, value) {
  if ((0, _graphql.isScalarType)(argType)) {
    try {
      switch (argType.name) {
        case 'String':
          return {
            kind: 'StringValue',
            value: String(argType.parseValue(value))
          };

        case 'Float':
          return {
            kind: 'FloatValue',
            value: String(argType.parseValue(parseFloat(value)))
          };

        case 'Int':
          return {
            kind: 'IntValue',
            value: String(argType.parseValue(parseInt(value, 10)))
          };

        case 'Boolean':
          try {
            var parsed = JSON.parse(value);

            if (typeof parsed === 'boolean') {
              return {
                kind: 'BooleanValue',
                value: parsed
              };
            }

            return {
              kind: 'BooleanValue',
              value: false
            };
          } catch (e) {
            return {
              kind: 'BooleanValue',
              value: false
            };
          }

        default:
          return {
            kind: 'StringValue',
            value: String(argType.parseValue(value))
          };
      }
    } catch (e) {
      console.error('error coercing arg value', e, value);
      return {
        kind: 'StringValue',
        value: value
      };
    }
  } else {
    try {
      var parsedValue = argType.parseValue(value);

      if (parsedValue) {
        return {
          kind: 'EnumValue',
          value: String(parsedValue)
        };
      }

      return {
        kind: 'EnumValue',
        value: argType.getValues()[0].name
      };
    } catch (e) {
      return {
        kind: 'EnumValue',
        value: argType.getValues()[0].name
      };
    }
  }
}

var InputArgView =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(InputArgView, _React$PureComponent);

  function InputArgView() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, InputArgView);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(InputArgView)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "_previousArgSelection", void 0);

    _defineProperty(_assertThisInitialized(_this), "_getArgSelection", function () {
      return _this.props.selection.fields.find(function (field) {
        return field.name.value === _this.props.arg.name;
      });
    });

    _defineProperty(_assertThisInitialized(_this), "_removeArg", function () {
      var selection = _this.props.selection;

      var argSelection = _this._getArgSelection();

      _this._previousArgSelection = argSelection;

      _this.props.modifyFields(selection.fields.filter(function (field) {
        return field !== argSelection;
      }));
    });

    _defineProperty(_assertThisInitialized(_this), "_addArg", function () {
      var _this$props = _this.props,
          selection = _this$props.selection,
          arg = _this$props.arg,
          getDefaultScalarArgValue = _this$props.getDefaultScalarArgValue,
          parentField = _this$props.parentField,
          makeDefaultArg = _this$props.makeDefaultArg;
      var argType = unwrapInputType(arg.type);
      var argSelection = null;

      if (_this._previousArgSelection) {
        argSelection = _this._previousArgSelection;
      } else if ((0, _graphql.isInputObjectType)(argType)) {
        var _fields = argType.getFields();

        argSelection = {
          kind: 'ObjectField',
          name: {
            kind: 'Name',
            value: arg.name
          },
          value: {
            kind: 'ObjectValue',
            fields: defaultInputObjectFields(getDefaultScalarArgValue, makeDefaultArg, parentField, Object.keys(_fields).map(function (k) {
              return _fields[k];
            }))
          }
        };
      } else if ((0, _graphql.isLeafType)(argType)) {
        argSelection = {
          kind: 'ObjectField',
          name: {
            kind: 'Name',
            value: arg.name
          },
          value: getDefaultScalarArgValue(parentField, arg, argType)
        };
      }

      if (!argSelection) {
        console.error('Unable to add arg for argType', argType);
      } else {
        _this.props.modifyFields([].concat(_toConsumableArray(selection.fields || []), [argSelection]));
      }
    });

    _defineProperty(_assertThisInitialized(_this), "_setArgValue", function (event) {
      var selection = _this.props.selection;

      var argSelection = _this._getArgSelection();

      if (!argSelection) {
        console.error('missing arg selection when setting arg value');
        return;
      }

      var argType = unwrapInputType(_this.props.arg.type);

      if (!(0, _graphql.isLeafType)(argType)) {
        console.warn('Unable to handle non leaf types in setArgValue');
        return;
      }

      var targetValue = event.target.value;

      _this.props.modifyFields((selection.fields || []).map(function (field) {
        return field === argSelection ? _objectSpread({}, field, {
          value: coerceArgValue(argType, targetValue)
        }) : field;
      }));
    });

    _defineProperty(_assertThisInitialized(_this), "_modifyChildFields", function (fields) {
      _this.props.modifyFields(_this.props.selection.fields.map(function (field) {
        return field.name.value === _this.props.arg.name ? _objectSpread({}, field, {
          value: {
            kind: 'ObjectValue',
            fields: fields
          }
        }) : field;
      }));
    });

    return _this;
  }

  _createClass(InputArgView, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          arg = _this$props2.arg,
          parentField = _this$props2.parentField;

      var argSelection = this._getArgSelection();

      return _react.default.createElement(AbstractArgView, {
        argValue: argSelection ? argSelection.value : null,
        arg: arg,
        parentField: parentField,
        addArg: this._addArg,
        removeArg: this._removeArg,
        setArgFields: this._modifyChildFields,
        setArgValue: this._setArgValue,
        getDefaultScalarArgValue: this.props.getDefaultScalarArgValue,
        makeDefaultArg: this.props.makeDefaultArg
      });
    }
  }]);

  return InputArgView;
}(_react.default.PureComponent);

function defaultValue(argType) {
  if ((0, _graphql.isEnumType)(argType)) {
    return {
      kind: 'EnumValue',
      value: argType.getValues()[0].name
    };
  }

  switch (argType.name) {
    case 'String':
      return {
        kind: 'StringValue',
        value: ''
      };

    case 'Float':
      return {
        kind: 'FloatValue',
        value: '1.5'
      };

    case 'Int':
      return {
        kind: 'IntValue',
        value: '10'
      };

    case 'Boolean':
      return {
        kind: 'BooleanValue',
        value: false
      };

    default:
      return {
        kind: 'StringValue',
        value: ''
      };
  }
}

function defaultGetDefaultScalarArgValue(parentField, arg, argType) {
  return defaultValue(argType);
}

var ArgView =
/*#__PURE__*/
function (_React$PureComponent2) {
  _inherits(ArgView, _React$PureComponent2);

  function ArgView() {
    var _getPrototypeOf3;

    var _this2;

    _classCallCheck(this, ArgView);

    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    _this2 = _possibleConstructorReturn(this, (_getPrototypeOf3 = _getPrototypeOf(ArgView)).call.apply(_getPrototypeOf3, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this2), "_previousArgSelection", void 0);

    _defineProperty(_assertThisInitialized(_this2), "_getArgSelection", function () {
      var selection = _this2.props.selection;
      return (selection.arguments || []).find(function (arg) {
        return arg.name.value === _this2.props.arg.name;
      });
    });

    _defineProperty(_assertThisInitialized(_this2), "_removeArg", function () {
      var selection = _this2.props.selection;

      var argSelection = _this2._getArgSelection();

      _this2._previousArgSelection = argSelection;

      _this2.props.modifyArguments((selection.arguments || []).filter(function (arg) {
        return arg !== argSelection;
      }));
    });

    _defineProperty(_assertThisInitialized(_this2), "_addArg", function () {
      var _this2$props = _this2.props,
          selection = _this2$props.selection,
          getDefaultScalarArgValue = _this2$props.getDefaultScalarArgValue,
          makeDefaultArg = _this2$props.makeDefaultArg,
          parentField = _this2$props.parentField,
          arg = _this2$props.arg;
      var argType = unwrapInputType(arg.type);
      var argSelection = null;

      if (_this2._previousArgSelection) {
        argSelection = _this2._previousArgSelection;
      } else if ((0, _graphql.isInputObjectType)(argType)) {
        var _fields2 = argType.getFields();

        argSelection = {
          kind: 'Argument',
          name: {
            kind: 'Name',
            value: arg.name
          },
          value: {
            kind: 'ObjectValue',
            fields: defaultInputObjectFields(getDefaultScalarArgValue, makeDefaultArg, parentField, Object.keys(_fields2).map(function (k) {
              return _fields2[k];
            }))
          }
        };
      } else if ((0, _graphql.isLeafType)(argType)) {
        argSelection = {
          kind: 'Argument',
          name: {
            kind: 'Name',
            value: arg.name
          },
          value: getDefaultScalarArgValue(parentField, arg, argType)
        };
      }

      if (!argSelection) {
        console.error('Unable to add arg for argType', argType);
      } else {
        _this2.props.modifyArguments([].concat(_toConsumableArray(selection.arguments || []), [argSelection]));
      }
    });

    _defineProperty(_assertThisInitialized(_this2), "_setArgValue", function (event) {
      var selection = _this2.props.selection;

      var argSelection = _this2._getArgSelection();

      if (!argSelection) {
        console.error('missing arg selection when setting arg value');
        return;
      }

      var argType = unwrapInputType(_this2.props.arg.type);

      if (!(0, _graphql.isLeafType)(argType)) {
        console.warn('Unable to handle non leaf types in setArgValue');
        return;
      }

      var targetValue = event.target.value;

      _this2.props.modifyArguments((selection.arguments || []).map(function (a) {
        return a === argSelection ? _objectSpread({}, a, {
          value: coerceArgValue(argType, targetValue)
        }) : a;
      }));
    });

    _defineProperty(_assertThisInitialized(_this2), "_setArgFields", function (fields) {
      var selection = _this2.props.selection;

      var argSelection = _this2._getArgSelection();

      if (!argSelection) {
        console.error('missing arg selection when setting arg value');
        return;
      }

      _this2.props.modifyArguments((selection.arguments || []).map(function (a) {
        return a === argSelection ? _objectSpread({}, a, {
          value: {
            kind: 'ObjectValue',
            fields: fields
          }
        }) : a;
      }));
    });

    return _this2;
  }

  _createClass(ArgView, [{
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          arg = _this$props3.arg,
          parentField = _this$props3.parentField;

      var argSelection = this._getArgSelection();

      return _react.default.createElement(AbstractArgView, {
        argValue: argSelection ? argSelection.value : null,
        arg: arg,
        parentField: parentField,
        addArg: this._addArg,
        removeArg: this._removeArg,
        setArgFields: this._setArgFields,
        setArgValue: this._setArgValue,
        getDefaultScalarArgValue: this.props.getDefaultScalarArgValue,
        makeDefaultArg: this.props.makeDefaultArg
      });
    }
  }]);

  return ArgView;
}(_react.default.PureComponent);

var ScalarInput =
/*#__PURE__*/
function (_React$PureComponent3) {
  _inherits(ScalarInput, _React$PureComponent3);

  function ScalarInput() {
    var _getPrototypeOf4;

    var _this3;

    _classCallCheck(this, ScalarInput);

    for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
      args[_key3] = arguments[_key3];
    }

    _this3 = _possibleConstructorReturn(this, (_getPrototypeOf4 = _getPrototypeOf(ScalarInput)).call.apply(_getPrototypeOf4, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this3), "_ref", void 0);

    _defineProperty(_assertThisInitialized(_this3), "_handleChange", function (event) {
      _this3.props.setArgValue(event);
    });

    return _this3;
  }

  _createClass(ScalarInput, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var input = this._ref;
      var activeElement = document.activeElement;

      if (input && activeElement && !(activeElement instanceof HTMLTextAreaElement)) {
        input.focus();
        input.setSelectionRange(0, input.value.length);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var _this$props4 = this.props,
          arg = _this$props4.arg,
          argValue = _this$props4.argValue;
      var argType = unwrapInputType(arg.type);
      var color = this.props.argValue.kind === 'StringValue' ? '#D64292' : '#2882F9';
      var value = typeof argValue.value === 'string' ? argValue.value : '';
      return _react.default.createElement("span", {
        style: {
          color: color
        }
      }, argType.name === 'String' ? '"' : '', _react.default.createElement("input", {
        style: {
          border: 'none',
          borderBottom: '1px solid #888',
          outline: 'none',
          color: color,
          width: "".concat(Math.max(1, value.length), "ch")
        },
        ref: function ref(_ref) {
          _this4._ref = _ref;
        },
        type: "text",
        onChange: this._handleChange,
        value: value
      }), argType.name === 'String' ? '"' : '');
    }
  }]);

  return ScalarInput;
}(_react.default.PureComponent);

var AbstractArgView =
/*#__PURE__*/
function (_React$PureComponent4) {
  _inherits(AbstractArgView, _React$PureComponent4);

  function AbstractArgView() {
    _classCallCheck(this, AbstractArgView);

    return _possibleConstructorReturn(this, _getPrototypeOf(AbstractArgView).apply(this, arguments));
  }

  _createClass(AbstractArgView, [{
    key: "render",
    value: function render() {
      var _this5 = this;

      var _this$props5 = this.props,
          argValue = _this$props5.argValue,
          arg = _this$props5.arg; // TODO: handle List types

      var argType = unwrapInputType(arg.type);
      var input = null;

      if (argValue) {
        if (argValue.kind === 'Variable') {
          input = _react.default.createElement("span", {
            style: {
              color: '#397D13'
            }
          }, '$', argValue.name.value);
        } else if ((0, _graphql.isScalarType)(argType)) {
          if (argType.name === 'Boolean') {
            input = _react.default.createElement("select", {
              style: {
                backgroundColor: 'white',
                color: '#D47509'
              },
              onChange: this.props.setArgValue,
              value: argValue.kind === 'BooleanValue' ? argValue.value : undefined
            }, _react.default.createElement("option", {
              key: "true",
              value: "true"
            }, 'true'), _react.default.createElement("option", {
              key: "false",
              value: "false"
            }, 'false'));
          } else {
            input = _react.default.createElement(ScalarInput, {
              setArgValue: this.props.setArgValue,
              arg: arg,
              argValue: argValue
            });
          }
        } else if ((0, _graphql.isEnumType)(argType)) {
          if (argValue.kind === 'EnumValue') {
            input = _react.default.createElement("select", {
              style: {
                backgroundColor: 'white',
                color: '#0B7FC7'
              },
              onChange: this.props.setArgValue,
              value: argValue.value
            }, argType.getValues().map(function (value) {
              return _react.default.createElement("option", {
                key: value.name,
                value: value.name
              }, value.name);
            }));
          } else {
            console.error('arg mismatch between arg and selection', argType, argValue);
          }
        } else if ((0, _graphql.isInputObjectType)(argType)) {
          if (argValue.kind === 'ObjectValue') {
            var _fields3 = argType.getFields();

            input = _react.default.createElement("div", {
              style: {
                marginLeft: 16
              }
            }, Object.keys(_fields3).map(function (fieldName) {
              return _react.default.createElement(InputArgView, {
                key: fieldName,
                arg: _fields3[fieldName],
                parentField: _this5.props.parentField,
                selection: argValue,
                modifyFields: _this5.props.setArgFields,
                getDefaultScalarArgValue: _this5.props.getDefaultScalarArgValue,
                makeDefaultArg: _this5.props.makeDefaultArg
              });
            }));
          } else {
            console.error('arg mismatch between arg and selection', argType, argValue);
          }
        }
      }

      return _react.default.createElement("div", {
        "data-arg-name": arg.name,
        "data-arg-type": argType.name
      }, _react.default.createElement("span", {
        style: {
          cursor: 'pointer'
        },
        onClick: argValue ? this.props.removeArg : this.props.addArg
      }, _react.default.createElement("input", {
        readOnly: true,
        type: "checkbox",
        checked: Boolean(argValue)
      }), _react.default.createElement("span", {
        title: arg.description,
        style: {
          color: '#8B2BB9'
        }
      }, arg.name, isRequiredArgument(arg) ? '*' : '', ':')), ' ', input);
    }
  }]);

  return AbstractArgView;
}(_react.default.PureComponent);

var AbstractView =
/*#__PURE__*/
function (_React$PureComponent5) {
  _inherits(AbstractView, _React$PureComponent5);

  function AbstractView() {
    var _getPrototypeOf5;

    var _this6;

    _classCallCheck(this, AbstractView);

    for (var _len4 = arguments.length, args = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
      args[_key4] = arguments[_key4];
    }

    _this6 = _possibleConstructorReturn(this, (_getPrototypeOf5 = _getPrototypeOf(AbstractView)).call.apply(_getPrototypeOf5, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this6), "_previousSelection", void 0);

    _defineProperty(_assertThisInitialized(_this6), "_addFragment", function () {
      _this6.props.modifySelections([].concat(_toConsumableArray(_this6.props.selections), [_this6._previousSelection || {
        kind: 'InlineFragment',
        typeCondition: {
          kind: 'NamedType',
          name: {
            kind: 'Name',
            value: _this6.props.implementingType.name
          }
        },
        selectionSet: {
          kind: 'SelectionSet',
          selections: _this6.props.getDefaultFieldNames(_this6.props.implementingType).map(function (fieldName) {
            return {
              kind: 'Field',
              name: {
                kind: 'Name',
                value: fieldName
              }
            };
          })
        }
      }]));
    });

    _defineProperty(_assertThisInitialized(_this6), "_removeFragment", function () {
      var thisSelection = _this6._getSelection();

      _this6._previousSelection = thisSelection;

      _this6.props.modifySelections(_this6.props.selections.filter(function (s) {
        return s !== thisSelection;
      }));
    });

    _defineProperty(_assertThisInitialized(_this6), "_getSelection", function () {
      var selection = _this6.props.selections.find(function (sel) {
        return sel.kind === 'InlineFragment' && sel.typeCondition && _this6.props.implementingType.name === sel.typeCondition.name.value;
      });

      if (!selection) {
        return null;
      }

      if (selection.kind === 'InlineFragment') {
        return selection;
      }
    });

    _defineProperty(_assertThisInitialized(_this6), "_modifyChildSelections", function (selections) {
      var thisSelection = _this6._getSelection();

      _this6.props.modifySelections(_this6.props.selections.map(function (selection) {
        if (selection === thisSelection) {
          return {
            directives: selection.directives,
            kind: 'InlineFragment',
            typeCondition: {
              kind: 'NamedType',
              name: {
                kind: 'Name',
                value: _this6.props.implementingType.name
              }
            },
            selectionSet: {
              kind: 'SelectionSet',
              selections: selections
            }
          };
        }

        return selection;
      }));
    });

    return _this6;
  }

  _createClass(AbstractView, [{
    key: "render",
    value: function render() {
      var _this7 = this;

      var _this$props6 = this.props,
          implementingType = _this$props6.implementingType,
          schema = _this$props6.schema,
          getDefaultFieldNames = _this$props6.getDefaultFieldNames;

      var selection = this._getSelection();

      var fields = implementingType.getFields();
      var childSelections = selection ? selection.selectionSet ? selection.selectionSet.selections : [] : [];
      return _react.default.createElement("div", null, _react.default.createElement("span", {
        style: {
          cursor: 'pointer'
        },
        onClick: selection ? this._removeFragment : this._addFragment
      }, _react.default.createElement("input", {
        readOnly: true,
        type: "checkbox",
        checked: Boolean(selection)
      }), _react.default.createElement("span", {
        style: {
          color: '#CA9800'
        }
      }, this.props.implementingType.name)), selection ? _react.default.createElement("div", {
        style: {
          marginLeft: 16
        }
      }, Object.keys(fields).sort().map(function (fieldName) {
        return _react.default.createElement(FieldView, {
          key: fieldName,
          field: fields[fieldName],
          selections: childSelections,
          modifySelections: _this7._modifyChildSelections,
          schema: schema,
          getDefaultFieldNames: getDefaultFieldNames,
          getDefaultScalarArgValue: _this7.props.getDefaultScalarArgValue,
          makeDefaultArg: _this7.props.makeDefaultArg
        });
      })) : null);
    }
  }]);

  return AbstractView;
}(_react.default.PureComponent);

function defaultInputObjectFields(getDefaultScalarArgValue, makeDefaultArg, parentField, fields) {
  var nodes = [];
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = fields[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var field = _step.value;

      if ((0, _graphql.isRequiredInputField)(field) || makeDefaultArg && makeDefaultArg(parentField, field)) {
        var fieldType = unwrapInputType(field.type);

        if ((0, _graphql.isInputObjectType)(fieldType)) {
          (function () {
            var fieldMap = fieldType.getFields();
            nodes.push({
              kind: 'ObjectField',
              name: {
                kind: 'Name',
                value: field.name
              },
              value: {
                kind: 'ObjectValue',
                fields: defaultInputObjectFields(getDefaultScalarArgValue, makeDefaultArg, parentField, Object.keys(fieldMap).map(function (k) {
                  return fieldMap[k];
                }))
              }
            });
          })();
        } else if ((0, _graphql.isLeafType)(fieldType)) {
          nodes.push({
            kind: 'ObjectField',
            name: {
              kind: 'Name',
              value: field.name
            },
            value: getDefaultScalarArgValue(parentField, field, fieldType)
          });
        }
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return != null) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return nodes;
}

function defaultArgs(getDefaultScalarArgValue, makeDefaultArg, field) {
  var args = [];
  var _iteratorNormalCompletion2 = true;
  var _didIteratorError2 = false;
  var _iteratorError2 = undefined;

  try {
    for (var _iterator2 = field.args[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
      var _arg = _step2.value;

      if (isRequiredArgument(_arg) || makeDefaultArg && makeDefaultArg(field, _arg)) {
        var argType = unwrapInputType(_arg.type);

        if ((0, _graphql.isInputObjectType)(argType)) {
          (function () {
            var fields = argType.getFields();
            args.push({
              kind: 'Argument',
              name: {
                kind: 'Name',
                value: _arg.name
              },
              value: {
                kind: 'ObjectValue',
                fields: defaultInputObjectFields(getDefaultScalarArgValue, makeDefaultArg, field, Object.keys(fields).map(function (k) {
                  return fields[k];
                }))
              }
            });
          })();
        } else if ((0, _graphql.isLeafType)(argType)) {
          args.push({
            kind: 'Argument',
            name: {
              kind: 'Name',
              value: _arg.name
            },
            value: getDefaultScalarArgValue(field, _arg, argType)
          });
        }
      }
    }
  } catch (err) {
    _didIteratorError2 = true;
    _iteratorError2 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion2 && _iterator2.return != null) {
        _iterator2.return();
      }
    } finally {
      if (_didIteratorError2) {
        throw _iteratorError2;
      }
    }
  }

  return args;
}

var FieldView =
/*#__PURE__*/
function (_React$PureComponent6) {
  _inherits(FieldView, _React$PureComponent6);

  function FieldView() {
    var _getPrototypeOf6;

    var _this8;

    _classCallCheck(this, FieldView);

    for (var _len5 = arguments.length, args = new Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
      args[_key5] = arguments[_key5];
    }

    _this8 = _possibleConstructorReturn(this, (_getPrototypeOf6 = _getPrototypeOf(FieldView)).call.apply(_getPrototypeOf6, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this8), "_previousSelection", void 0);

    _defineProperty(_assertThisInitialized(_this8), "_addFieldToSelections", function () {
      return _this8.props.modifySelections([].concat(_toConsumableArray(_this8.props.selections), [_this8._previousSelection || {
        kind: 'Field',
        name: {
          kind: 'Name',
          value: _this8.props.field.name
        },
        arguments: defaultArgs(_this8.props.getDefaultScalarArgValue, _this8.props.makeDefaultArg, _this8.props.field)
      }]));
    });

    _defineProperty(_assertThisInitialized(_this8), "_removeFieldFromSelections", function () {
      var previousSelection = _this8._getSelection();

      _this8._previousSelection = previousSelection;

      _this8.props.modifySelections(_this8.props.selections.filter(function (selection) {
        return selection !== previousSelection;
      }));
    });

    _defineProperty(_assertThisInitialized(_this8), "_getSelection", function () {
      var selection = _this8.props.selections.find(function (sel) {
        return sel.kind === 'Field' && _this8.props.field.name === sel.name.value;
      });

      if (!selection) {
        return null;
      }

      if (selection.kind === 'Field') {
        return selection;
      }
    });

    _defineProperty(_assertThisInitialized(_this8), "_setArguments", function (argumentNodes) {
      var selection = _this8._getSelection();

      if (!selection) {
        console.error('Missing selection when setting arguments', argumentNodes);
        return;
      }

      _this8.props.modifySelections(_this8.props.selections.map(function (s) {
        return s === selection ? {
          alias: selection.alias,
          arguments: argumentNodes,
          directives: selection.directives,
          kind: 'Field',
          name: selection.name,
          selectionSet: selection.selectionSet
        } : s;
      }));
    });

    _defineProperty(_assertThisInitialized(_this8), "_modifyChildSelections", function (selections) {
      _this8.props.modifySelections(_this8.props.selections.map(function (selection) {
        if (selection.kind === 'Field' && _this8.props.field.name === selection.name.value) {
          if (selection.kind !== 'Field') {
            throw new Error('invalid selection');
          }

          return {
            alias: selection.alias,
            arguments: selection.arguments,
            directives: selection.directives,
            kind: 'Field',
            name: selection.name,
            selectionSet: {
              kind: 'SelectionSet',
              selections: selections
            }
          };
        }

        return selection;
      }));
    });

    return _this8;
  }

  _createClass(FieldView, [{
    key: "render",
    value: function render() {
      var _this9 = this;

      var _this$props7 = this.props,
          field = _this$props7.field,
          schema = _this$props7.schema,
          getDefaultFieldNames = _this$props7.getDefaultFieldNames;

      var selection = this._getSelection();

      var type = unwrapOutputType(field.type);
      var args = field.args;

      var node = _react.default.createElement("div", {
        className: "graphiql-explorer-node"
      }, _react.default.createElement("span", {
        title: field.description,
        style: {
          cursor: 'pointer'
        },
        "data-field-name": field.name,
        "data-field-type": type.name,
        onClick: selection ? this._removeFieldFromSelections : this._addFieldToSelections
      }, _react.default.createElement("input", {
        readOnly: true,
        type: "checkbox",
        checked: Boolean(selection)
      }), _react.default.createElement("span", {
        style: {
          color: 'rgb(31, 97, 160)'
        }
      }, field.name)), selection && args.length ? _react.default.createElement("div", {
        style: {
          marginLeft: 16
        }
      }, args.map(function (arg) {
        return _react.default.createElement(ArgView, {
          key: arg.name,
          parentField: field,
          arg: arg,
          selection: selection,
          modifyArguments: _this9._setArguments,
          getDefaultScalarArgValue: _this9.props.getDefaultScalarArgValue,
          makeDefaultArg: _this9.props.makeDefaultArg
        });
      })) : null);

      if (selection && ((0, _graphql.isObjectType)(type) || (0, _graphql.isInterfaceType)(type) || (0, _graphql.isUnionType)(type))) {
        var _fields4 = (0, _graphql.isUnionType)(type) ? {} : type.getFields();

        var childSelections = selection ? selection.selectionSet ? selection.selectionSet.selections : [] : [];
        return _react.default.createElement("div", null, node, _react.default.createElement("div", {
          style: {
            marginLeft: 16
          }
        }, Object.keys(_fields4).sort().map(function (fieldName) {
          return _react.default.createElement(FieldView, {
            key: fieldName,
            field: _fields4[fieldName],
            selections: childSelections,
            modifySelections: _this9._modifyChildSelections,
            schema: schema,
            getDefaultFieldNames: getDefaultFieldNames,
            getDefaultScalarArgValue: _this9.props.getDefaultScalarArgValue,
            makeDefaultArg: _this9.props.makeDefaultArg
          });
        }), (0, _graphql.isInterfaceType)(type) || (0, _graphql.isUnionType)(type) ? schema.getPossibleTypes(type).map(function (typ) {
          return _react.default.createElement(AbstractView, {
            key: typ.name,
            implementingType: typ,
            selections: childSelections,
            modifySelections: _this9._modifyChildSelections,
            schema: schema,
            getDefaultFieldNames: getDefaultFieldNames,
            getDefaultScalarArgValue: _this9.props.getDefaultScalarArgValue,
            makeDefaultArg: _this9.props.makeDefaultArg
          });
        }) : null));
      }

      return node;
    }
  }]);

  return FieldView;
}(_react.default.PureComponent);

function parseQuery(text) {
  try {
    if (!text.trim()) {
      return null;
    }

    return (0, _graphql.parse)(text, {
      noLocation: true
    });
  } catch (e) {
    return new Error(e);
  }
}

var DEFAULT_DOCUMENT = {
  kind: 'Document',
  definitions: []
};
var parseQueryMemoize = null;

function memoizeParseQuery(query) {
  if (parseQueryMemoize && parseQueryMemoize[0] === query) {
    return parseQueryMemoize[1];
  }

  var result = parseQuery(query);

  if (!result) {
    return DEFAULT_DOCUMENT;
  } else if (result instanceof Error) {
    if (parseQueryMemoize) {
      // Most likely a temporarily invalid query while they type
      return parseQueryMemoize[1];
    }

    return DEFAULT_DOCUMENT;
  }

  parseQueryMemoize = [query, result];
  return result;
}

var RootView =
/*#__PURE__*/
function (_React$PureComponent7) {
  _inherits(RootView, _React$PureComponent7);

  function RootView() {
    var _getPrototypeOf7;

    var _this10;

    _classCallCheck(this, RootView);

    for (var _len6 = arguments.length, args = new Array(_len6), _key6 = 0; _key6 < _len6; _key6++) {
      args[_key6] = arguments[_key6];
    }

    _this10 = _possibleConstructorReturn(this, (_getPrototypeOf7 = _getPrototypeOf(RootView)).call.apply(_getPrototypeOf7, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this10), "_previousOperationDef", void 0);

    _defineProperty(_assertThisInitialized(_this10), "_getOperationDef", function (parsedQuery) {
      var operation = parsedQuery.definitions.find(function (d) {
        return d.kind === 'OperationDefinition' && d.operation === _this10.props.operation;
      });
      var result = operation || {
        kind: 'OperationDefinition',
        operation: _this10.props.operation,
        selectionSet: {
          kind: 'SelectionSet',
          selections: []
        }
      };

      if (result.kind !== 'OperationDefinition') {
        throw new Error('invalid operation');
      }

      return result;
    });

    _defineProperty(_assertThisInitialized(_this10), "_modifySelections", function (selections) {
      var parsedQuery = _this10.props.parsedQuery;

      var operationDef = _this10._getOperationDef(parsedQuery);

      if (operationDef.selectionSet.selections.length === 0 && _this10._previousOperationDef) {
        operationDef = _this10._previousOperationDef;
      }

      if (selections.length === 0) {
        _this10._previousOperationDef = operationDef;

        _this10.props.onEdit((0, _graphql.print)(_objectSpread({}, parsedQuery, {
          definitions: parsedQuery.definitions.filter(function (d) {
            return d !== operationDef;
          })
        })));
      } else {
        var newOperationDef = _objectSpread({}, operationDef, {
          selectionSet: _objectSpread({}, operationDef.selectionSet, {
            selections: selections
          })
        });

        var replaced = false;
        var newDefinitions = parsedQuery.definitions.map(function (op) {
          if (op === operationDef) {
            replaced = true;
            return newOperationDef;
          }

          return op;
        });

        _this10.props.onEdit((0, _graphql.print)(_objectSpread({}, parsedQuery, {
          definitions: replaced ? newDefinitions : [newOperationDef].concat(_toConsumableArray(newDefinitions))
        })));
      }
    });

    return _this10;
  }

  _createClass(RootView, [{
    key: "render",
    value: function render() {
      var _this11 = this;

      var _this$props8 = this.props,
          fields = _this$props8.fields,
          operation = _this$props8.operation,
          parsedQuery = _this$props8.parsedQuery,
          schema = _this$props8.schema,
          getDefaultFieldNames = _this$props8.getDefaultFieldNames;

      var operationDef = this._getOperationDef(parsedQuery);

      var selections = operationDef.selectionSet.selections;
      return _react.default.createElement("div", {
        style: {
          borderBottom: operation !== 'subscription' ? '1px solid #d6d6d6' : '',
          marginBottom: '1em',
          paddingBottom: '0.5em'
        }
      }, _react.default.createElement("div", {
        style: {
          color: '#B11A04',
          paddingBottom: 4
        }
      }, operation), Object.keys(fields).sort().map(function (fieldName) {
        return _react.default.createElement(FieldView, {
          key: fieldName,
          field: fields[fieldName],
          selections: selections,
          modifySelections: _this11._modifySelections,
          schema: schema,
          getDefaultFieldNames: getDefaultFieldNames,
          getDefaultScalarArgValue: _this11.props.getDefaultScalarArgValue,
          makeDefaultArg: _this11.props.makeDefaultArg
        });
      }));
    }
  }]);

  return RootView;
}(_react.default.PureComponent);

var Explorer =
/*#__PURE__*/
function (_React$PureComponent8) {
  _inherits(Explorer, _React$PureComponent8);

  function Explorer() {
    var _getPrototypeOf8;

    var _this12;

    _classCallCheck(this, Explorer);

    for (var _len7 = arguments.length, args = new Array(_len7), _key7 = 0; _key7 < _len7; _key7++) {
      args[_key7] = arguments[_key7];
    }

    _this12 = _possibleConstructorReturn(this, (_getPrototypeOf8 = _getPrototypeOf(Explorer)).call.apply(_getPrototypeOf8, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this12), "_ref", void 0);

    _defineProperty(_assertThisInitialized(_this12), "_resetScroll", function () {
      var container = _this12._ref;

      if (container) {
        container.scrollLeft = 0;
      }
    });

    _defineProperty(_assertThisInitialized(_this12), "_onEdit", function (query) {
      return _this12.props.onEdit(query);
    });

    return _this12;
  }

  _createClass(Explorer, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this._resetScroll();
    }
  }, {
    key: "render",
    value: function render() {
      var _this13 = this;

      var _this$props9 = this.props,
          schema = _this$props9.schema,
          query = _this$props9.query,
          makeDefaultArg = _this$props9.makeDefaultArg;

      if (!schema) {
        return _react.default.createElement("div", {
          style: {
            fontFamily: 'sans-serif'
          },
          className: "error-container"
        }, 'No Schema Available');
      }

      var queryType = schema.getQueryType();
      var mutationType = schema.getMutationType();
      var subscriptionType = schema.getSubscriptionType();

      if (!queryType && !mutationType && !subscriptionType) {
        return _react.default.createElement("div", null, 'Missing query type');
      }

      var queryFields = queryType && queryType.getFields();
      var mutationFields = mutationType && mutationType.getFields();
      var subscriptionFields = subscriptionType && subscriptionType.getFields();
      var parsedQuery = memoizeParseQuery(query);
      var getDefaultFieldNames = this.props.getDefaultFieldNames || defaultGetDefaultFieldNames;
      var getDefaultScalarArgValue = this.props.getDefaultScalarArgValue || defaultGetDefaultScalarArgValue;
      return _react.default.createElement("div", {
        ref: function ref(_ref2) {
          _this13._ref = _ref2;
        },
        style: {
          fontSize: 12,
          textOverflow: 'ellipsis',
          whiteSpace: 'nowrap',
          margin: 0,
          padding: 8,
          fontFamily: 'Consolas, Inconsolata, "Droid Sans Mono", Monaco, monospace'
        },
        className: "graphiql-explorer-root"
      }, queryFields ? _react.default.createElement(RootView, {
        fields: queryFields,
        operation: "query",
        parsedQuery: parsedQuery,
        onEdit: this._onEdit,
        schema: schema,
        getDefaultFieldNames: getDefaultFieldNames,
        getDefaultScalarArgValue: getDefaultScalarArgValue,
        makeDefaultArg: makeDefaultArg
      }) : null, mutationFields ? _react.default.createElement(RootView, {
        fields: mutationFields,
        operation: "mutation",
        parsedQuery: parsedQuery,
        onEdit: this._onEdit,
        schema: schema,
        getDefaultFieldNames: getDefaultFieldNames,
        getDefaultScalarArgValue: getDefaultScalarArgValue,
        makeDefaultArg: makeDefaultArg
      }) : null, subscriptionFields ? _react.default.createElement(RootView, {
        fields: subscriptionFields,
        operation: "subscription",
        parsedQuery: parsedQuery,
        onEdit: this._onEdit,
        schema: schema,
        getDefaultFieldNames: getDefaultFieldNames,
        getDefaultScalarArgValue: getDefaultScalarArgValue,
        makeDefaultArg: makeDefaultArg
      }) : null);
    }
  }]);

  return Explorer;
}(_react.default.PureComponent);

_defineProperty(Explorer, "defaultProps", {
  getDefaultFieldNames: defaultGetDefaultFieldNames,
  getDefaultScalarArgValue: defaultGetDefaultScalarArgValue
});

var ErrorBoundary =
/*#__PURE__*/
function (_React$Component) {
  _inherits(ErrorBoundary, _React$Component);

  function ErrorBoundary() {
    var _getPrototypeOf9;

    var _this14;

    _classCallCheck(this, ErrorBoundary);

    for (var _len8 = arguments.length, args = new Array(_len8), _key8 = 0; _key8 < _len8; _key8++) {
      args[_key8] = arguments[_key8];
    }

    _this14 = _possibleConstructorReturn(this, (_getPrototypeOf9 = _getPrototypeOf(ErrorBoundary)).call.apply(_getPrototypeOf9, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this14), "state", {
      hasError: false,
      error: null,
      errorInfo: null
    });

    return _this14;
  }

  _createClass(ErrorBoundary, [{
    key: "componentDidCatch",
    value: function componentDidCatch(error, errorInfo) {
      this.setState({
        hasError: true,
        error: error,
        errorInfo: errorInfo
      });
      console.error('Error in component', error, errorInfo);
    }
  }, {
    key: "render",
    value: function render() {
      if (this.state.hasError) {
        return _react.default.createElement("div", {
          style: {
            padding: 18,
            fontFamily: 'sans-serif'
          }
        }, _react.default.createElement("div", null, 'Something went wrong'), _react.default.createElement("details", {
          style: {
            whiteSpace: 'pre-wrap'
          }
        }, this.state.error ? this.state.error.toString() : null, _react.default.createElement("br", null), this.state.errorInfo ? this.state.errorInfo.componentStack : null));
      }

      return this.props.children;
    }
  }]);

  return ErrorBoundary;
}(_react.default.Component);

var ExplorerWrapper =
/*#__PURE__*/
function (_React$PureComponent9) {
  _inherits(ExplorerWrapper, _React$PureComponent9);

  function ExplorerWrapper() {
    _classCallCheck(this, ExplorerWrapper);

    return _possibleConstructorReturn(this, _getPrototypeOf(ExplorerWrapper).apply(this, arguments));
  }

  _createClass(ExplorerWrapper, [{
    key: "render",
    value: function render() {
      return _react.default.createElement("div", {
        className: "historyPaneWrap",
        style: {
          height: '100%',
          width: this.props.width,
          zIndex: 7,
          display: this.props.explorerIsOpen ? 'block' : 'none'
        }
      }, _react.default.createElement("div", {
        className: "history-title-bar"
      }, _react.default.createElement("div", {
        className: "history-title"
      }, 'Explorer'), _react.default.createElement("div", {
        className: "doc-explorer-rhs"
      }, _react.default.createElement("div", {
        className: "docExplorerHide",
        onClick: this.props.onToggleExplorer
      }, "\u2715"))), _react.default.createElement("div", {
        className: "history-contents"
      }, _react.default.createElement(ErrorBoundary, null, _react.default.createElement(Explorer, this.props))));
    }
  }]);

  return ExplorerWrapper;
}(_react.default.PureComponent);

_defineProperty(ExplorerWrapper, "defaultValue", defaultValue);

_defineProperty(ExplorerWrapper, "defaultProps", {
  width: 380
});

var _default = ExplorerWrapper;
exports.default = _default;